#import "NX_Window.h"

#define NX_TITLE_BAR_HEIGHT 20.0

#define NX_BOTTOM_BAR_HEIGHT 8.0

#define NX_RESIZE_INDICATOR_WIDTH	20.0

@implementation NX_WindowThemeFrame

+ (NSMutableDictionary *) _fontDictionary
{
	static NSMutableDictionary * sFontDictionary=nil;
	
	sFontDictionary=[NSMutableDictionary dictionaryWithObjectsAndKeys:[NSFont systemFontOfSize:12.0f], NSFontAttributeName,nil];
	
	return sFontDictionary;
}

- (void) drawRect:(NSRect) inRect
{
	NSRect tBounds;
	NSString * tString;
	NSRect tBoundingRect;
	NSRect tTitleRect;
	NSMutableDictionary * tMutableDictionary;
	
	tBounds=[self bounds];
	
	// Background
	
	[[NSColor colorWithDeviceWhite:0.666f alpha:1.0f] set];
	
	NSRectFill(tBounds);
	
	// Frame
	
	[[NSColor blackColor] set];
	
	NSFrameRect(tBounds);
	
	// Title Bar
	
	titleBar_=tBounds;
	titleBar_.origin.y=NSMaxY(titleBar_)-NX_TITLE_BAR_HEIGHT-1;
	titleBar_.size.height=NX_TITLE_BAR_HEIGHT+1;
	
	if (isKey_==YES)
	{
		NSRectFill(titleBar_);
		
		[[NSColor colorWithDeviceWhite:0.666f alpha:1.0f] set];
		
		[NSBezierPath strokeLineFromPoint:NSMakePoint(1.5f,NSMaxY(tBounds)-NX_TITLE_BAR_HEIGHT) toPoint:NSMakePoint(1.5,NSMaxY(tBounds)-1.5f)];
		
		[NSBezierPath strokeLineFromPoint:NSMakePoint(1.0f,NSMaxY(tBounds)-1.5f) toPoint:NSMakePoint(NSMaxX(tBounds)-1.0,NSMaxY(tBounds)-1.5)];
		
		[[NSColor colorWithDeviceWhite:0.333 alpha:1.0f] set];
		
		[NSBezierPath strokeLineFromPoint:NSMakePoint(NSMaxX(tBounds)-1.5f,NSMaxY(tBounds)-NX_TITLE_BAR_HEIGHT) toPoint:NSMakePoint(NSMaxX(tBounds)-1.5f,NSMaxY(tBounds)-2.0f)];
		
		[NSBezierPath strokeLineFromPoint:NSMakePoint(2.0f,NSMaxY(tBounds)-NX_TITLE_BAR_HEIGHT+0.5f) toPoint:NSMakePoint(NSMaxX(tBounds)-2.0f,NSMaxY(tBounds)-NX_TITLE_BAR_HEIGHT+0.5f)];
	}
	else
	{
		[NSBezierPath strokeLineFromPoint:NSMakePoint(0.0f,NSMaxY(tBounds)-NX_TITLE_BAR_HEIGHT-0.5f) toPoint:NSMakePoint(NSMaxX(tBounds),NSMaxY(tBounds)-NX_TITLE_BAR_HEIGHT-0.5f)];
		
		[[NSColor whiteColor] set];
		
		[NSBezierPath strokeLineFromPoint:NSMakePoint(1.5f,NSMaxY(tBounds)-NX_TITLE_BAR_HEIGHT) toPoint:NSMakePoint(1.5,NSMaxY(tBounds)-1.5f)];
		
		[NSBezierPath strokeLineFromPoint:NSMakePoint(1.0f,NSMaxY(tBounds)-1.5f) toPoint:NSMakePoint(NSMaxX(tBounds)-1.0,NSMaxY(tBounds)-1.5)];
		

		
		[[NSColor colorWithDeviceWhite:0.3608f alpha:1.0f] set];
		
		[NSBezierPath strokeLineFromPoint:NSMakePoint(NSMaxX(tBounds)-1.5f,NSMaxY(tBounds)-NX_TITLE_BAR_HEIGHT+1.0f) toPoint:NSMakePoint(NSMaxX(tBounds)-1.5f,NSMaxY(tBounds)-2.0f)];
		
		[NSBezierPath strokeLineFromPoint:NSMakePoint(2.0f,NSMaxY(tBounds)-NX_TITLE_BAR_HEIGHT+0.5f) toPoint:NSMakePoint(NSMaxX(tBounds)-2.0f,NSMaxY(tBounds)-NX_TITLE_BAR_HEIGHT+0.5f)];
		
		[[NSColor colorWithDeviceWhite:0.2667 alpha:1.0f] set];
		
		[NSBezierPath strokeLineFromPoint:NSMakePoint(NSMaxX(tBounds)-1.0f,NSMaxY(tBounds)-NX_TITLE_BAR_HEIGHT+0.5f) toPoint:NSMakePoint(NSMaxX(tBounds)-2.0f,NSMaxY(tBounds)-NX_TITLE_BAR_HEIGHT+0.5f)];
	}
	
	
	tString=[[self window] title];
	
	tMutableDictionary=[NX_WindowThemeFrame _fontDictionary];
	
	tBoundingRect=[tString boundingRectWithSize:NSMakeSize(NSWidth(tBounds),NX_TITLE_BAR_HEIGHT) options:0 attributes:tMutableDictionary];
	
	tTitleRect=NSMakeRect(roundf(NSMidX(tBounds)-0.5f*NSWidth(tBoundingRect)),NSMaxY(tBounds)-NX_TITLE_BAR_HEIGHT*0.5-0.5*NSHeight(tBoundingRect),NSWidth(tBoundingRect),NSHeight(tBoundingRect));
	
	if (isKey_==YES)
	{
		[tMutableDictionary setObject:[NSColor whiteColor] forKey:NSForegroundColorAttributeName];
	}
	else
	{
		[tMutableDictionary setObject:[NSColor blackColor] forKey:NSForegroundColorAttributeName];
	}
	
	[tString drawInRect:tTitleRect withAttributes:tMutableDictionary];
	
	// Bottom Bar
	
	leftResizeIndicator_=tBounds;
	leftResizeIndicator_.size.width=NX_RESIZE_INDICATOR_WIDTH+1;
	leftResizeIndicator_.size.height=NX_BOTTOM_BAR_HEIGHT;
	
	rightResizeIndicator_=tBounds;
	rightResizeIndicator_.origin.x=NSMaxX(rightResizeIndicator_)-NX_RESIZE_INDICATOR_WIDTH-1;
	rightResizeIndicator_.size.width=NX_RESIZE_INDICATOR_WIDTH+1;
	rightResizeIndicator_.size.height=NX_BOTTOM_BAR_HEIGHT;
	
	
	[[NSColor colorWithDeviceWhite:0.3059 alpha:1.0f] set];
	
	[NSBezierPath strokeLineFromPoint:NSMakePoint(1.0f,NSMinY(tBounds)+NX_BOTTOM_BAR_HEIGHT-0.5f) toPoint:NSMakePoint(NSMaxX(tBounds)-1.0,NSMinY(tBounds)+NX_BOTTOM_BAR_HEIGHT-0.5f)];
	
	[NSBezierPath strokeLineFromPoint:NSMakePoint(NX_RESIZE_INDICATOR_WIDTH-0.5f,NSMinY(tBounds)+1.0f) toPoint:NSMakePoint(NX_RESIZE_INDICATOR_WIDTH-0.5f,NSMinY(tBounds)+NX_BOTTOM_BAR_HEIGHT-2.0f)];
	
	[NSBezierPath strokeLineFromPoint:NSMakePoint(NSMaxX(tBounds)-NX_RESIZE_INDICATOR_WIDTH-0.5f,NSMinY(tBounds)+1.0f) toPoint:NSMakePoint(NSMaxX(tBounds)-NX_RESIZE_INDICATOR_WIDTH-0.5f,NSMinY(tBounds)+NX_BOTTOM_BAR_HEIGHT-2.0f)];


	[[NSColor whiteColor] set];
	
	[NSBezierPath strokeLineFromPoint:NSMakePoint(1.0f,NSMinY(tBounds)+NX_BOTTOM_BAR_HEIGHT-1.5f) toPoint:NSMakePoint(NSMaxX(tBounds)-1.0,NSMinY(tBounds)+NX_BOTTOM_BAR_HEIGHT-1.5f)];
	
	[NSBezierPath strokeLineFromPoint:NSMakePoint(NX_RESIZE_INDICATOR_WIDTH+0.5f,NSMinY(tBounds)+1.0f) toPoint:NSMakePoint(NX_RESIZE_INDICATOR_WIDTH+0.5f,NSMinY(tBounds)+NX_BOTTOM_BAR_HEIGHT-2.0f)];
	
	[NSBezierPath strokeLineFromPoint:NSMakePoint(NSMaxX(tBounds)-NX_RESIZE_INDICATOR_WIDTH+0.5f,NSMinY(tBounds)+1.0f) toPoint:NSMakePoint(NSMaxX(tBounds)-NX_RESIZE_INDICATOR_WIDTH+0.5f,NSMinY(tBounds)+NX_BOTTOM_BAR_HEIGHT-2.0f)];
}

- (void) mouseDown:(NSEvent *) inEvent
{
	NSPoint tMouseLoc;
	
	tMouseLoc=[self convertPoint:[inEvent locationInWindow] fromView:nil];
	
	if (NSMouseInRect(tMouseLoc,titleBar_,[self isFlipped])==YES)
    {
		/*if ([inEvent clickCount]==2)
		{
			[[self window] miniaturize:self];
		}*/
		
		interactionMode_=NX_InteractionMode_Drag;
	}
	else if (NSMouseInRect(tMouseLoc,leftResizeIndicator_,[self isFlipped])==YES)
    {
		interactionMode_=NX_InteractionMode_ResizeLeft;
	}
	else if (NSMouseInRect(tMouseLoc,rightResizeIndicator_,[self isFlipped])==YES)
    {
		interactionMode_=NX_InteractionMode_ResizeRight;
	}
}

- (void) setIsKey:(BOOL) aBool
{
	if (aBool!=isKey_)
	{
		isKey_=aBool;

		[self setNeedsDisplay:YES];
	}
}

- (void) mouseDragged:(NSEvent *) inEvent
{
	if (interactionMode_!=NX_InteractionMode_None)
	{
		NSWindow * tWindow;
		NSPoint tPoint;
		NSRect tRect;
		float tHeight;
		float tWidth;
		
		tWindow=[self window];
		
		tRect=[tWindow frame];
		
		switch(interactionMode_)
		{
			case NX_InteractionMode_None:
			
				break;
				
			case NX_InteractionMode_Drag:
			
				tPoint=tRect.origin;
				
				[tWindow setFrameOrigin:NSMakePoint(tPoint.x+[inEvent deltaX],tPoint.y-[inEvent deltaY])];
				
				break;
				
			case NX_InteractionMode_ResizeLeft:
			
				tWidth=tRect.size.width-[inEvent deltaX];
				
				if (tWidth<([tWindow minSize].width))
				{
					tWidth=[tWindow minSize].width;
				}
				else if (tWidth>([tWindow maxSize].width))
				{
					tWidth=[tWindow maxSize].width;
				}
				
				tRect.origin.x-=tWidth-NSWidth(tRect);
				
				tRect.size.width=tWidth;
				
				tHeight=tRect.size.height+[inEvent deltaY];
				
				if (tHeight<([tWindow minSize].height))
				{
					tHeight=[tWindow minSize].height;
				}
				else if (tHeight>([tWindow maxSize].height))
				{
					tHeight=[tWindow maxSize].height;
				}
				
				tRect.origin.y-=tHeight-NSHeight(tRect);
				
				tRect.size.height=tHeight;
				
				[tWindow setFrame:tRect display:YES];
				
				break;
				
			case NX_InteractionMode_ResizeRight:
			
				tRect.size.width+=[inEvent deltaX];
				
				if (NSWidth(tRect)<([tWindow minSize].width))
				{
					tRect.size.width=[tWindow minSize].width;
				}
				else if (NSWidth(tRect)>([tWindow maxSize].width))
				{
					tRect.size.width=[tWindow maxSize].width;
				}
				
				tHeight=tRect.size.height+[inEvent deltaY];
				
				if (tHeight<([tWindow minSize].height))
				{
					tHeight=[tWindow minSize].height;
				}
				else if (tHeight>([tWindow maxSize].height))
				{
					tHeight=[tWindow maxSize].height;
				}
				
				tRect.origin.y-=tHeight-NSHeight(tRect);
				
				tRect.size.height=tHeight;
				
				[tWindow setFrame:tRect display:YES];
			
				break;
		}
	}
}

- (void) mouseUp:(NSEvent *) inEvent
{
	interactionMode_=NX_InteractionMode_None;
}

- (BOOL) acceptsFirstMouse:(NSEvent *)theEvent
{
	return YES;
}

@end

@implementation NX_Window

- (id) initWithContentRect:(NSRect) inFrame styleMask:(NSUInteger) inStyle backing:(NSBackingStoreType) inType defer:(BOOL) aFlag
{
	self=[super initWithContentRect:inFrame styleMask:NSBorderlessWindowMask backing:inType defer:aFlag];
		
	if (self!=nil)
	{
		[self setOpaque:NO];
		
		[self setBackgroundColor: [NSColor clearColor]];
	}
	
	return self;
}

- (void) awakeFromNib
{
	[IBminiaturizeButton_ setBezelStyle:0];
	
	[IBcloseButton_ setBezelStyle:0];
	
	[self makeKeyWindow];
}

#pragma mark -

- (IBAction) close:(id) sender
{
	[self close];
}

- (void)becomeKeyWindow
{
	[[self contentView] setIsKey:YES];
	
	[super becomeKeyWindow];
}

- (void) resignKeyWindow
{
	[[self contentView] setIsKey:NO];
	
	[super resignKeyWindow];
}

- (BOOL) canBecomeKeyWindow
{
	return YES;
}

- (BOOL) canBecomeMainWindow
{
	return YES;
}

@end
