#import "MainController.h"

@implementation MainController

- (void) awakeFromNib
{
	_closeButton=[IBwindow_ standardWindowButton:NSWindowCloseButton];
	
	_miniaturizeButton=[IBwindow_ standardWindowButton:NSWindowMiniaturizeButton];
	
	_zoomButton=[IBwindow_ standardWindowButton:NSWindowZoomButton];
	
	[IBwindow_ center];
	
	[IBwindow_ makeKeyAndOrderFront:nil];
	
	[self animationButtons];
}

- (void) animationButtons
{
	NSViewAnimation * tViewAnimation;
	NSRect tMiniaturizeStartRect;
	NSRect tMiniaturizeStopRect;
	NSRect tZoomStartRect;
	NSRect tZoomStopRect;
	static BOOL sBOOL=NO;
	
	sBOOL=!sBOOL;
	
	tMiniaturizeStartRect=[_miniaturizeButton frame];
	
	tMiniaturizeStopRect=NSOffsetRect([_closeButton frame],0,-20);
	
	tZoomStartRect=[_zoomButton frame];
	
	tZoomStopRect=NSOffsetRect(tMiniaturizeStopRect,0,-20);
	
	[IBwindow_ setShowsResizeIndicator:NO];
	
	tViewAnimation=[[NSViewAnimation alloc] initWithViewAnimations:[NSArray arrayWithObjects:[NSDictionary dictionaryWithObjectsAndKeys:_miniaturizeButton,NSViewAnimationTargetKey,
																																		[NSValue valueWithRect:tMiniaturizeStartRect],NSViewAnimationStartFrameKey,
																																		[NSValue valueWithRect:tMiniaturizeStopRect],NSViewAnimationEndFrameKey,
																																		nil],
																							 [NSDictionary dictionaryWithObjectsAndKeys:_zoomButton,NSViewAnimationTargetKey,
																																		[NSValue valueWithRect:tZoomStartRect],NSViewAnimationStartFrameKey,
																																		[NSValue valueWithRect:tZoomStopRect],NSViewAnimationEndFrameKey,
																																		nil],
																							 nil]];
	
	
	[tViewAnimation setDelegate:self];
	
	[tViewAnimation startAnimation];
}

- (void) animationDidEnd:(NSAnimation *) inAnimation
{
	[inAnimation release];
}

@end
