#import "WBPresentationViewTwo.h"

static NSWindow * sHelperWindow=nil;

static NSImage * sHelperImage=nil;

#define WB_PRESENTATION_WINDOW_CORNER_SIZE_LEFT		100.0f
#define WB_PRESENTATION_WINDOW_CORNER_SIZE			50.0f
#define WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT	50.0f

@implementation WBPresentationViewTwo

- (id) initWithFrame:(NSRect) inFrame
{
    self = [super initWithFrame:inFrame];
	
    if (self)
	{
        // Initialization code here.
    }
	
    return self;
}

#pragma mark -

+ (void) setHelperWindow:(NSWindow *) inWindow
{
	if (inWindow!=sHelperWindow)
	{
		[sHelperWindow release];
		
		[sHelperImage release];
		
		sHelperImage=nil;
		
		sHelperWindow=[inWindow retain];
		
		if (sHelperWindow!=nil)
		{
			CGImageRef tImageRef;
			
			[sHelperWindow makeKeyAndOrderFront:self];
			
			tImageRef = CGWindowListCreateImage(CGRectNull, kCGWindowListOptionIncludingWindow, [sHelperWindow windowNumber], kCGWindowImageDefault);
			
			[sHelperWindow orderOut:self];
			
			if (tImageRef!=NULL)
			{
				NSBitmapImageRep * tBitmapRep;
				
				tBitmapRep = [[NSBitmapImageRep alloc] initWithCGImage:tImageRef];
				
				if (tBitmapRep!=nil)
				{
					NSSize tSnapshotSize;
					
					tSnapshotSize=[tBitmapRep size];
				
					sHelperImage = [[NSImage alloc] initWithSize:tSnapshotSize];
				
					if (sHelperImage!=nil)
					{
						[sHelperImage addRepresentation:tBitmapRep];
					}
				
					[tBitmapRep release];
				}
				
				// Release Memory
				
				CFRelease(tImageRef);
			}
		}
	}
}

#pragma mark -

- (void) drawRect:(NSRect) inRect
{
    if (sHelperImage!=nil)
	{
		NSRect tBounds;
		NSRect tHelperBounds;
		
		tBounds=[self bounds];
		
		tHelperBounds.origin=NSZeroPoint;
		tHelperBounds.size=[sHelperImage size];
		
		// Left
		
		[sHelperImage drawInRect:NSMakeRect(0,0,WB_PRESENTATION_WINDOW_CORNER_SIZE,WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT)
						fromRect:NSMakeRect(0,0,WB_PRESENTATION_WINDOW_CORNER_SIZE,WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT)
					   operation:NSCompositeSourceOver 
						fraction:1.0f];
		
		[sHelperImage drawInRect:NSMakeRect(0,WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT,WB_PRESENTATION_WINDOW_CORNER_SIZE,NSHeight(tBounds)-2*WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT)
						fromRect:NSMakeRect(0,WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT,WB_PRESENTATION_WINDOW_CORNER_SIZE,WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT)
					   operation:NSCompositeSourceOver 
						fraction:1.0f];
	
		[sHelperImage drawInRect:NSMakeRect(0,NSMaxY(tBounds)-WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT,WB_PRESENTATION_WINDOW_CORNER_SIZE_LEFT,WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT)
						fromRect:NSMakeRect(0,NSMaxY(tHelperBounds)-WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT,WB_PRESENTATION_WINDOW_CORNER_SIZE_LEFT,WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT)
					   operation:NSCompositeSourceOver 
						fraction:1.0f];
		
		[sHelperImage drawInRect:NSMakeRect(WB_PRESENTATION_WINDOW_CORNER_SIZE_LEFT,NSMaxY(tBounds)-WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT,NSWidth(tBounds)-(WB_PRESENTATION_WINDOW_CORNER_SIZE+WB_PRESENTATION_WINDOW_CORNER_SIZE_LEFT),WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT)
						fromRect:NSMakeRect(WB_PRESENTATION_WINDOW_CORNER_SIZE_LEFT,NSMaxY(tHelperBounds)-WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT,WB_PRESENTATION_WINDOW_CORNER_SIZE,WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT)
					   operation:NSCompositeSourceOver 
						fraction:1.0f];
		
		
		[sHelperImage drawInRect:NSMakeRect(NSMaxX(tBounds)-WB_PRESENTATION_WINDOW_CORNER_SIZE,NSMaxY(tBounds)-WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT,WB_PRESENTATION_WINDOW_CORNER_SIZE,WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT)
						fromRect:NSMakeRect(NSMaxX(tHelperBounds)-WB_PRESENTATION_WINDOW_CORNER_SIZE,NSMaxY(tHelperBounds)-WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT,WB_PRESENTATION_WINDOW_CORNER_SIZE,WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT)
					   operation:NSCompositeSourceOver 
						fraction:1.0f];
		
		[sHelperImage drawInRect:NSMakeRect(NSMaxX(tBounds)-WB_PRESENTATION_WINDOW_CORNER_SIZE,WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT,WB_PRESENTATION_WINDOW_CORNER_SIZE,NSHeight(tBounds)-2*WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT)
						fromRect:NSMakeRect(NSMaxX(tHelperBounds)-WB_PRESENTATION_WINDOW_CORNER_SIZE,WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT,WB_PRESENTATION_WINDOW_CORNER_SIZE,WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT)
					   operation:NSCompositeSourceOver 
						fraction:1.0f];
		
		[sHelperImage drawInRect:NSMakeRect(NSMaxX(tBounds)-WB_PRESENTATION_WINDOW_CORNER_SIZE,0,WB_PRESENTATION_WINDOW_CORNER_SIZE,WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT)
						fromRect:NSMakeRect(NSMaxX(tHelperBounds)-WB_PRESENTATION_WINDOW_CORNER_SIZE,0,WB_PRESENTATION_WINDOW_CORNER_SIZE,WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT)
					   operation:NSCompositeSourceOver 
						fraction:1.0f];
		
		[sHelperImage drawInRect:NSMakeRect(WB_PRESENTATION_WINDOW_CORNER_SIZE,0,NSWidth(tBounds)-2*WB_PRESENTATION_WINDOW_CORNER_SIZE,WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT)
						fromRect:NSMakeRect(WB_PRESENTATION_WINDOW_CORNER_SIZE,0,WB_PRESENTATION_WINDOW_CORNER_SIZE,WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT)
					   operation:NSCompositeSourceOver 
						fraction:1.0f];
		
		
		[sHelperImage drawInRect:NSMakeRect(WB_PRESENTATION_WINDOW_CORNER_SIZE_LEFT,WB_PRESENTATION_WINDOW_CORNER_SIZE,NSWidth(tBounds)-(WB_PRESENTATION_WINDOW_CORNER_SIZE+WB_PRESENTATION_WINDOW_CORNER_SIZE_LEFT),NSHeight(tBounds)-2*WB_PRESENTATION_WINDOW_CORNER_SIZE_HEIGHT)
						fromRect:NSMakeRect(WB_PRESENTATION_WINDOW_CORNER_SIZE,WB_PRESENTATION_WINDOW_CORNER_SIZE,2,2)
					   operation:NSCompositeSourceOver 
						fraction:1.0f];
	}
}

@end
